import sys
import numpy as np

resultsFileName = "output/second.sp" #default pass in
testFileName = "irisTest.txt"#default pass in

#EXAMPLE_TIME = 30.0
EXAMPLE_TIME = 50.0

#This reads in the spike file, ignoring training spikes (before testStartTime)
#
def readResultsFile(testStartTime):
    timeResults = [[],[],[]]
    fileHandle = open(resultsFileName)
    inputLine = fileHandle.readline()
    while (inputLine != ""):
        dataStrings = inputLine.split()
        neuronNumber = int (dataStrings[0])
        spikeTime = float(dataStrings[1])
        if (spikeTime >= testStartTime):
            timeResults[neuronNumber] = timeResults[neuronNumber]+ [spikeTime]
        inputLine = fileHandle.readline()

    fileHandle.close()
    return timeResults

def convertTestSpikeTimesToPerExample(testSpikeTimes,testStartTime,exampleTime):
    answer0 = np.zeros(75)
    for spikeTimeOffset in range (0,len(testSpikeTimes[0])):
        actualSpikeTime = testSpikeTimes[0][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        if (exampleOffset >= 75):
            print 'firing beyond end in cat 0', actualSpikeTime
        else:
            answer0[exampleOffset] = answer0[exampleOffset] + 1

    answer1 = np.zeros(75)
    for spikeTimeOffset in range (0,len(testSpikeTimes[1])):
        actualSpikeTime = testSpikeTimes[1][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >= 75):
            print 'firing beyond end in cat 1', actualSpikeTime
        else:
            answer1[exampleOffset] = answer1[exampleOffset] + 1

    answer2 = np.zeros(75)
    for spikeTimeOffset in range (0,len(testSpikeTimes[2])):
        actualSpikeTime = testSpikeTimes[2][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >= 75):
            print 'firing beyond end in cat 2', actualSpikeTime
        else:
            answer2[exampleOffset] = answer2[exampleOffset] + 1

    spikesPerExample = [answer0,answer1,answer2]
    return spikesPerExample

def printSpikesPerExample(spikesPerExample):
    for answerOffset in range (0,75):
        print spikesPerExample[0][answerOffset],spikesPerExample[1][answerOffset], spikesPerExample[2][answerOffset]

def convertSpikesToAnswers(spikesPerExample):
    answers = []

    for answerOffset in range (0,75):
        answer = -1
        oneSpikes = spikesPerExample[0][answerOffset]
        twoSpikes = spikesPerExample[1][answerOffset]
        threeSpikes = spikesPerExample[2][answerOffset]
        #real answers
        if (oneSpikes > twoSpikes) and (oneSpikes > threeSpikes): #1 > 2&3
            answer = 1
        elif (twoSpikes > oneSpikes) and (twoSpikes > threeSpikes): #2 > 1&3
            answer = 2
        elif (threeSpikes > oneSpikes) and (threeSpikes > twoSpikes): #3 > 1&2
            answer = 3
        #no answer
        elif (oneSpikes == 0) and (twoSpikes == 0) and (threeSpikes == 0):#1=2=3
            answer = -2
        elif (oneSpikes == twoSpikes) and (twoSpikes == threeSpikes):#1=2=3
            answer = -3
        elif (oneSpikes == twoSpikes) and (twoSpikes > threeSpikes):#1=2>3
            answer = -4
        elif (twoSpikes == threeSpikes) and (twoSpikes > oneSpikes):#2=3>1
            answer = -5
        elif (oneSpikes == threeSpikes) and (oneSpikes>twoSpikes):#1=3>2
            answer = -6
        else: answer = -7
        
        answers = answers + [answer]

    return answers

def getGoldStandardAnswers(testFileName):
    answers = []
    fileHandle = open(testFileName)
    for lineNumber in range (0,75):
        inputLine = fileHandle.readline()
        dataStrings = inputLine.split()
        answer = int(dataStrings[4])
        answers = answers + [answer]
    return answers

def compare (systemAnswers,goldAnswers):
    correctAnswers = 0
    noInputAnswers = 0
    allEqualAnswers = 0
    onesAndTwosEqual = 0
    onesAndThreesEqual = 0
    twosAndThreesEqual = 0
    for answerOffset in range (0,75):
        if (systemAnswers[answerOffset] == goldAnswers[answerOffset]):
            correctAnswers = correctAnswers + 1
            #print "correct", goldAnswers[answerOffset]
        elif ((systemAnswers[answerOffset] == -2) and
              (goldAnswers[answerOffset] ==  3)):
            noInputAnswers = noInputAnswers + 1
        elif ((systemAnswers[answerOffset] == -3) and
              (goldAnswers[answerOffset] ==  2)):
            allEqualAnswers = allEqualAnswers + 1
        elif ((systemAnswers[answerOffset] == -4) and
              (goldAnswers[answerOffset] ==  2)):
            onesAndTwosEqual = onesAndTwosEqual +1
        elif ((systemAnswers[answerOffset] == -5) and
              (goldAnswers[answerOffset] ==  3)):
            twosAndThreesEqual = twosAndThreesEqual +1
        elif ((systemAnswers[answerOffset] == -6) and
              (goldAnswers[answerOffset] ==  3)):
            onesAndThreesEqual = onesAndThreesEqual +1
        else:
            a = 1
            print systemAnswers[answerOffset] , goldAnswers[answerOffset]

    print correctAnswers,noInputAnswers, allEqualAnswers,onesAndTwosEqual,onesAndThreesEqual,twosAndThreesEqual,correctAnswers+noInputAnswers+allEqualAnswers+onesAndTwosEqual+onesAndThreesEqual+twosAndThreesEqual

##--main---
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 4):
    startTime = float(args[1])
    testFileName = args[2]
    resultsFileName = args[3]
elif (numberArgs == 2):
    startTime = float(args[1])
else:
    startTime = 1100

print startTime,testFileName,resultsFileName
testSpikeTimes = readResultsFile(startTime)
spikesPerExample = convertTestSpikeTimesToPerExample(testSpikeTimes,startTime,EXAMPLE_TIME)
systemAnswers = convertSpikesToAnswers(spikesPerExample)
goldStandardAnswers = getGoldStandardAnswers(testFileName)

compare(systemAnswers,goldStandardAnswers)

#printSpikesPerExample(spikesPerExample)
#print systemAnswers
