import sys
import numpy as np

resultsFileName = "output/secondWisc.sp" #default pass in
testFileName = "wiscTest.txt"#default pass in

defaultCategory = 0
#EXAMPLE_TIME = 30.0
EXAMPLE_TIME = 50.0

#This reads in the spike file, ignoring training spikes (before testStartTime)
#
def readResultsFile(testStartTime):
    timeResults = [[],[],[]]
    fileHandle = open(resultsFileName)
    inputLine = fileHandle.readline()
    while (inputLine != ""):
        dataStrings = inputLine.split()
        neuronNumber = int (dataStrings[0])
        spikeTime = float(dataStrings[1])
        if (spikeTime >= testStartTime):
            timeResults[neuronNumber] = timeResults[neuronNumber]+ [spikeTime]
        inputLine = fileHandle.readline()

    fileHandle.close()
    return timeResults

def convertTestSpikeTimesToPerExample(testSpikeTimes,testStartTime,exampleTime, 
                                      numberDataItems):
    answer0 = np.zeros(numberDataItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[0])):
        actualSpikeTime = testSpikeTimes[0][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        if (exampleOffset >= numberDataItems):
            print 'firing beyond end in cat 0', actualSpikeTime
        else:
            answer0[exampleOffset] = answer0[exampleOffset] + 1

    answer1 = np.zeros(numberDataItems)
    for spikeTimeOffset in range (0,len(testSpikeTimes[1])):
        actualSpikeTime = testSpikeTimes[1][spikeTimeOffset]
        baseTime = actualSpikeTime-testStartTime
        exampleOffset = baseTime/exampleTime
        exampleOffset = int (exampleOffset)
        #print actualSpikeTime,baseTime,exampleOffset
        if (exampleOffset >= numberDataItems):
            print 'firing beyond end in cat 1', actualSpikeTime
        else:
            answer1[exampleOffset] = answer1[exampleOffset] + 1

    spikesPerExample = [answer0,answer1]
    return spikesPerExample

def printSpikesPerExample(spikesPerExample,numberDataItems):
    for answerOffset in range (0,numberDataItems):
        print spikesPerExample[0][answerOffset],spikesPerExample[1][answerOffset]

def convertSpikesToAnswers(spikesPerExample,numberDataItems):
    answers = []

    for answerOffset in range (0,numberDataItems):
        answer = -1
        oneSpikes = spikesPerExample[0][answerOffset]
        twoSpikes = spikesPerExample[1][answerOffset]
        #real answers
        if (oneSpikes > twoSpikes):
            answer = 0
        elif (twoSpikes > oneSpikes):
            answer = 1
        elif ((twoSpikes == oneSpikes) and (oneSpikes == 0)):
            answer = -2
        else: answer = -3
        
        answers = answers + [answer]

    return answers

def getGoldStandardAnswers(testFileName,numberDataItems):
    answers = []
    fileHandle = open(testFileName)
    for lineNumber in range (0,numberDataItems):
        inputLine = fileHandle.readline()
        dataStrings = inputLine.split()
        answer = int(dataStrings[10])
        if (answer == 2): 
            answer = 0
        elif (answer == 4): 
            answer = 1
        else:
            "error in evaluate answer ", answer

        answers = answers + [answer]
    return answers

def compare (systemAnswers,goldAnswers,numberDataItems):
    global defaultCategory
    correctAnswers = 0
    wrongAnswers = 0
    noInputAnswers = 0
    equalInputAnswers = 0
    for answerOffset in range (0,numberDataItems):
        if (systemAnswers[answerOffset] == goldAnswers[answerOffset]):
            correctAnswers = correctAnswers + 1
            #print "correct", goldAnswers[answerOffset]
        elif (systemAnswers[answerOffset] == -2):
            noInputAnswers = noInputAnswers + 1
            if (goldAnswers[answerOffset] == defaultCategory):
                correctAnswers = correctAnswers + 1
            else:
                wrongAnswers = wrongAnswers +1 
        elif (systemAnswers[answerOffset] == -3):
            equalInputAnswers = equalInputAnswers + 1
            if (goldAnswers[answerOffset] == defaultCategory):
                correctAnswers = correctAnswers + 1
            else:
                wrongAnswers = wrongAnswers +1 
        else:
            wrongAnswers = wrongAnswers +1 
            print systemAnswers[answerOffset] , goldAnswers[answerOffset]

    print correctAnswers, wrongAnswers, noInputAnswers, equalInputAnswers

##--main---
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 5):
    startTime = float(args[1])
    testFileName = args[2]
    resultsFileName = args[3]
    defaultCategory = int(args[4])
elif (numberArgs == 2):
    startTime = float(args[1])
else:
    startTime = 1100

if (testFileName == "wiscTest.txt"):
    numberDataItems = 350 #undone get this from the file 349 or 350
else: 
    numberDataItems = 349

print startTime,testFileName,resultsFileName
testSpikeTimes = readResultsFile(startTime)
spikesPerExample = convertTestSpikeTimesToPerExample(testSpikeTimes,startTime,
                                            EXAMPLE_TIME,numberDataItems)
systemAnswers = convertSpikesToAnswers(spikesPerExample,numberDataItems)
goldStandardAnswers = getGoldStandardAnswers(testFileName,numberDataItems)

compare(systemAnswers,goldStandardAnswers,numberDataItems)

#printSpikesPerExample(spikesPerExample)
#print systemAnswers
