"""
input at 10,30,50,70 wt = 0.035 none
input at 10,30,50,70 wt = 0.037 81 ms
input at 10,30,50,70 wt = 0.02  38ms
input at 10,30,50,70 wt = 0.05  18, 37 and 59ms
input at 10,20,30,40 wt = 0.023 none
input at 10,20,30,40 wt = 0.024 46ms
input at 10,20,30,40 wt = 0.025 39ms
input at 10,20,30,40 wt = 0.03  27 and 47
input at 10,13,16,19 wt = 0.0129 none
input at 10,13,16,19 wt = 0.013 28ms
input at 10,13,16,19 wt = 0.014 24ms
input at 10,12,14,16 wt = 0.01  none
input at 10,12,14,16 wt = 0.012  none
input at 10,12,14,16 wt = 0.01205  none
input at 10,12,14,16 wt = 0.0121 28ms
input at 10,12,14,16 wt = 0.0122 25ms
input at 10,12,14,16 wt = 0.0125 23ms
input at 10,12,14,16 wt = 0.013 22ms
input at 10,12,14,16 wt = 0.014 20ms
input at 10,12,14,16 wt = 0.015 20ms
input at 10,12,14,16 wt = 0.02  18ms
input at 10,12,14,16 wt = 0.03  16, and 20 ms
input at 10,12,14,16 wt = 0.04  15,19, and 28 ms
"""
import sys
import cPickle as pickle

import pyNN.nest as sim

import numpy as np
import random as Random


RUN_DURATION = 100
TIME_STEP = 1.0
numInhibCANeurons = 20
inhibToCASynapses = 30

numberNeurons = 1; 


#initialize the simulator. 
def init(): 
    sim.setup(timestep=TIME_STEP,min_delay=TIME_STEP,
                    max_delay=TIME_STEP, debug=0)

def createTwoInputs():
    #firstSpikeTime = 5.0
    #spikeInterval = 10.0
    #inputSpikeTimes0 = []
    #for spikeNumber in range (0,15):
    #    inputSpikeTimes0 = inputSpikeTimes0 + [
    #        firstSpikeTime + (spikeNumber*spikeInterval)]
    #print inputSpikeTimes0
    offset = 100
    start = 10.0
    inputSpikeTimes0 = [start,start+20.0,start+40.0,start+60.0]
    #inputSpikeTimes1 = [start,start+2.0,start+4.0,start+6.0]
    #inputSpikeTimes1 = [start,start+3.0,start+6.0,start+9.0]
    inputSpikeTimes1 = [start]
    #inputSpikeTimes1 = [start,start+10.0,start+20.0,start+30.0]
    spikeArray0 = {'spike_times': [inputSpikeTimes0]}
    spikeGen0=sim.Population(1,sim.SpikeSourceArray,spikeArray0,
                                   label='inputSpikes_0')
    spikeArray1 = {'spike_times': [inputSpikeTimes1]}
    spikeGen1=sim.Population(1, sim.SpikeSourceArray, spikeArray1,
                                   label='inputSpikes_1')

    return [spikeGen0,spikeGen1]


def createDefaultNeurons(numberNeurons):
    cells=sim.Population(numberNeurons,sim.EIF_cond_exp_isfa_ista,
                         cellparams={})
    return cells

def setupRecording(cells):
    cells.record({'spikes','v','w'})

def printResults(simCells,file):
    simCells.write_data(file+".pkl",'spikes')
    #simCells.write_data(file+"V.pkl",'v')
    #simCells.write_data(file+"W.pkl",'w')

##--main---
#args = sys.argv
#numberArgs = args.__len__()
#if (numberArgs == 2):
#    test = int(args[1])
#else:
#    test = 1


simName = "nest"
spinnVersion = -1

init()
spikeGenerators = createTwoInputs()
firstSpikeGenerator =  spikeGenerators[0]
secondSpikeGenerator =  spikeGenerators[1]

cells = createDefaultNeurons(numberNeurons)

firingWt = 0.024
firingWt = 0.05
connector = []
connector = connector + [(0,0,firingWt,TIME_STEP)]

#hook it up
fromListConnector = sim.FromListConnector(connector)
#sim.Projection(firstSpikeGenerator, cells, fromListConnector, 
a = sim.Projection(secondSpikeGenerator, cells, fromListConnector, 
               receptor_type='excitatory')
temp = a.get(["weight"],format="list")
print temp


setupRecording(cells)


sim.run(RUN_DURATION)

outputFileName = 'oneTemp'
printResults(cells,outputFileName)
sim.reset()
